//---------------------------------------------------------------------------
// GPGee - GNU Privacy Guard Explorer Extension
// GPGee.cpp - Project source - framework for the .dll
// Copyright 2005, Kurt Fitzner <kfitzner@excelcia.org>
//---------------------------------------------------------------------------
// This file is part of GPGee.
//
// GPGee is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// GPGee is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// File Notes:
// This is the project source file.  It is the basic framework for the DLL.
// It was originally generated by C++ Builder, but has had some code added
// to DLLEntryPoint() to set things up better.
//---------------------------------------------------------------------------

//$$---- axlib proj source ---- (stAXLibProjectSource)
#include <vcl.h>
#pragma hdrstop
#include <atl\atlvcl.h>

#include "gpgme/gpgme.h"
#include "TConfiguration.h"
#include "GPGeeContextMenuExtensionImpl.h"
USEFORM("GPGeeSignEncrypt.cpp", formGPGeeSignEncrypt);
USEFORM("GPGeePassPhrase.cpp", formGPGeePassPhrase);
USEFORM("GPGeeConfigure.cpp", formGPGeeConfigure);
//---------------------------------------------------------------------------
#pragma package(smart_init)
TComModule  GPGeeModule;
TComModule &_Module = GPGeeModule;
TConfiguration *GPGeeConfig = NULL;

//---------------------------------------------------------------------------
// The ATL Object map holds an array of _ATL_OBJMAP_ENTRY structures that
// described the objects of your OLE server. The MAP is handed to your
// project's CComModule-derived _Module object via the Init method.
//
BEGIN_OBJECT_MAP(ObjectMap)
  OBJECT_ENTRY(CLSID_GPGeeContextMenuExtension, TGPGeeContextMenuExtensionImpl)
END_OBJECT_MAP()
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Entry point of your Server invoked by Windows for processes or threads are
// initialized or terminated.
//
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
  static HWND Handle;

  switch (reason) {
    case DLL_PROCESS_ATTACH:
      _Module.Init(ObjectMap, hinst);
      DisableThreadLibraryCalls(hinst);
      Handle = Application->Handle;             // Fix the Application->Handle - give it the handle of the host application
      Application->Handle = GetActiveWindow();
      Application->Name = "GPGee";
      GPGeeConfig = new TConfiguration();       // Load the configuration
      gpgme_lib_init();                         // Set up the gpgme library
      break;

    case DLL_THREAD_ATTACH:
    case DLL_THREAD_DETACH:
      break;

    case DLL_PROCESS_DETACH:
      Application->Handle = Handle;             // Restore the Application->Handle
      if (GPGeeConfig)                          // Delete the configuration object
        delete GPGeeConfig;
      gpgme_lib_cleanup();                      // Clean up the gpgme library
      break;
  }  // switch (reason)
  return TRUE;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// _Module.Term is typically invoked from the DLL_PROCESS_DETACH of your
// DllEntryPoint. However, this may result in an incorrect shutdown sequence.
// Instead an Exit routine is setup to invoke the cleanup routine
// CComModule::Term.
//
void ModuleTerm(void)
{
    _Module.Term();
}
#pragma exit ModuleTerm 63
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Entry point of your Server invoked to inquire whether the DLL is no
// longer in use and should be unloaded.
//
STDAPI __export DllCanUnloadNow(void)
{
    return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Entry point of your Server allowing OLE to retrieve a class object from
// your Server
//
STDAPI __export DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _Module.GetClassObject(rclsid, riid, ppv);
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Entry point of your Server invoked to instruct the server to create
// registry entries for all classes supported by the module
//
STDAPI __export DllRegisterServer(void)
{
    return _Module.RegisterServer(TRUE);
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Entry point of your Server invoked to instruct the server to remove
// all registry entries created through DllRegisterServer.
//
STDAPI __export DllUnregisterServer(void)
{
    return _Module.UnregisterServer();
}
//---------------------------------------------------------------------------
